/*
 * sxdef2.h X68k SX_SYSTEM ver 2.01 Copyright 1994 SHARP/First Class Technology
 */
#ifndef __SXDEF2_H
#define __SXDEF2_H

#ifndef __CLASS_H
typedef int		BOOLEAN;	/* _^iTRUEFALSÊQl
					   ž^j			*/
#endif
typedef void		*Pointer;	/* |C^^iĔzus\ubNj*/
typedef void		**Handle;	/* nh^iĔzu\ubNj*/
typedef long		LPoint;		/* |Cg`			*/
typedef union Point	Point;		/* |CgR[h		*/
typedef union Rect	Rect;		/* N^OR[h		*/
typedef struct Region	Region;		/* [WR[h		*/
typedef unsigned short	BitImg;		/* rbgC[WR[h	*/
typedef unsigned char	LASCII[256];	/* LASCII^			*/
typedef struct Bitmap	Bitmap;		/* rbg}bvR[h		*/
typedef struct Graph	Graph;		/* OtR[h		*/
typedef enum EventCode	EventCode;	/* CxgR[h		*/
typedef struct Event	Event;		/* CxgR[h		*/
typedef struct Window	Window;		/* EBhER[h		*/
typedef struct Subwin	Subwin;		/* TuEBhER[h	*/
typedef union TsEvent	TsEvent;	/* ^XN}CxgR[h	*/
/*
 * ȉTypedef錾Ă\̂́Ae}l[W̃wb_t@C
 * ۂstruct錾sĂ܂Bp̍ۂ́AK̃wb_t@C
 * CN[hĂB
 */
typedef struct Heap	Heap;		/* q[vR[h		*/
typedef struct GScript	GScript;	/* OtXNvgR[h	*/
typedef struct Menu	Menu;		/* j[R[h		*/
typedef struct Control	Control;	/* Rg[R[h		*/
typedef struct Dialog	Dialog;		/* _CAOR[h		*/
typedef struct TEdit	TEdit;		/* eLXgGfBbgR[h	*/

#ifndef NULL
#define NULL		((void *) 0)	/* k|C^			*/
#endif
#ifndef FALSE
#define FALSE		0		/* _^̋U			*/
#endif
#ifndef TRUE
#define TRUE		1		/* _^̐^			*/
#endif
/*
 * wb ver2.1ł́Aϒf[^߂̔z錾͓Yȗ
 */
#ifndef _VARLEN
#define _VARLEN
#endif

#define HIBYTE(w)	((long)(w) >> 8 & 0x000000ff)	/* ʃoCg𓾂 */
#define LOWBYTE(w)	((long)(w) & 0x000000ff)	/* ʃoCg𓾂 */
#define HIWORD(l)	((long)(l) >> 16 & 0x0000ffff)	/* ʃ[h𓾂 */
#define LOWWORD(l)	((long)(l) & 0x0000ffff)	/* ʃ[h𓾂 */
#define LONGWORD(h,l)	((long)(h) << 16 | LOWWORD(l))	/* O[h𓾂 */
/*
 *	} (Memory Man)
 *
 * nh֐iMMChHdlNewAMMHdlDisposeȂǁj𗘗pՂ邽
 * Handle𑍏̓Iȃ|C^^void *ɒuĊ֐vg^Cvs
 */
#ifndef _Handle
#define _Handle		void *
#endif
/*
 *	L[{[h} (Keyboard Man)
 */
/* VtgL[rbg */
#define KS_SHIFT	1		/* [SHIFT]L[		*/
#define KS_CTRL		(1 << 1)	/* [CTRL]L[		*/
#define KS_OPT1		(1 << 2)	/* [OPT.1]L[		*/
#define KS_OPT2		(1 << 3)	/* [OPT.2]L[		*/
#define KS_KANA		(1 << 8)	/* []L[		*/
#define KS_ROMEJI	(1 << 9)	/* [[}]L[	*/
#define KS_CODEIN	(1 << 10)	/* [R[h]L[	*/
#define KS_CAPS		(1 << 11)	/* [CAPS]L[		*/
#define KS_INS		(1 << 12)	/* [INS]L[		*/
#define KS_HIRA		(1 << 13)	/* [Ђ炪]L[	*/
#define KS_ZEN		(1 << 14)	/* [Sp]L[		*/
#define KS_XF1		(1 << 16)	/* [XF1]L[		*/
#define KS_XF2		(1 << 17)	/* [XF2]L[		*/
#define KS_XF3		(1 << 18)	/* [XF3]L[		*/
#define KS_XF4		(1 << 19)	/* [XF4]L[		*/
#define KS_XF5		(1 << 20)	/* [XF5]L[		*/
/*
 *	Ot} (Graph Man)
 *
 * zLASCII֐vg^CvLXgŗpՂ邽
 * unsigned char *ɒuĎg
 */
#ifndef _LASCII
#define _LASCII		unsigned char *
#endif

union Point {				/* |CgR[h		*/
	struct {
		short x;		/* xW			*/
		short y;		/* yW			*/
	} p;
	LPoint x_y;			/* |Cg			*/
};

union Rect {				/* N^OR[h		*/
	struct {
		short left;		/* ̃|CgxW	*/
		short top;		/* ̃|CgyW	*/
		short right;		/* Ẽ|CgxW	*/
		short bottom;		/* Ẽ|CgyW	*/
	} d;
	struct {
		LPoint l_t;		/* ̃|Cg		*/
		LPoint r_b;		/* Ẽ|Cg		*/
	} l;
};

struct Region {				/* [WR[h		*/
	long size;			/* R[hŜ̃TCY		*/
	Rect bounds;			/* oEhN^O		*/
	short data[_VARLEN];		/* PC̃f[^iϒf[^j*/
};

struct Bitmap {				/* rbg}bvR[h		*/
	short type;			/* XN[^Cv		*/
	Rect rect;			/* rbg}bvN^O	*/
	char *base;			/* x[XAhX		*/
	short line;			/* PC̃oCg		*/
	union {
		struct {
			long page;	/* Py[W̃oCg		*/
			short aPage;	/* ANZXy[W		*/
		} tbm;
		unsigned short bRatio;	/* uhEFCgVI	*/
	} opt;
};

struct Graph {				/* OtR[h		*/
	Bitmap *bmap;			/* rbg}bv|C^		*/
	Rect rect;			/* OtN^O		*/
	long (**procs)();		/* vZX|C^		*/
	Region **visible;		/* rWu[Wnh	*/
	Region **clipping;		/* Nbv[Wnh	*/
	short drawLvl;			/* h[x			*/
	unsigned short penMode;		/* y[h			*/
	Point penLoc;			/* yʒu			*/
	Point penSize;			/* yTCY			*/
	BitImg *penPat;			/* yp^[ւ̃|C^	*/
	BitImg *exPat;			/* GNXehp^[ւ̃|C^ */
	short workKind;			/* VXeŎgp		*/
	Handle workHdl;			/* VXeŎgp		*/
	unsigned short fgColor;		/* tHAOEhJ[	*/
	unsigned short bgColor;		/* obNOEhJ[	*/
	short fontKind;			/* tHgJCh		*/
	unsigned short fontFace;	/* tHgtFCX		*/
	unsigned short fontMode;	/* tHg[h		*/
	Point fontSize;			/* tHgTCY		*/
};
/*
 *	Cxg} (Event Man)
 */
enum EventCode {			/* CxgR[h		*/
	E_IDLE,				/* AChCxg		*/
	E_MSLDOWN,			/* }EXtg_ECxg	*/
	E_MSLUP,			/* }EXtgAbvCxg	*/
	E_MSRDOWN,			/* }EXCg_ECxg	*/
	E_MSRUP,			/* }EXCgAbvCxg	*/
	E_KEYDOWN,			/* L[_ECxg		*/
	E_KEYUP,			/* L[AbvCxg		*/
	E_UPDATE,			/* Abvf[gCxg		*/
	E_RESERVE1,			/* VXe\P		*/
	E_ACTIVATE,			/* ANeBx[gCxg	*/
	E_RESERVE2,			/* VXe\Q		*/
	E_RESERVE3,			/* VXe\R		*/
	E_SYSTEM1,			/* VXeCxgP		*/
	E_SYSTEM2,			/* VXeCxgQ		*/
	E_USER1,			/* [U[CxgP		*/
	E_USER2		/* 15 */	/* [U[CxgQ		*/
};

/* Cxg}XN */
#define EM_IDLE		(1 << E_IDLE)	  /* AChCxg		*/
#define EM_MSLDOWN	(1 << E_MSLDOWN)  /* }EXtg_ECxg	*/
#define EM_MSLUP	(1 << E_MSLUP)	  /* }EXtgAbvCxg	*/
#define EM_MSRDOWN	(1 << E_MSRDOWN)  /* }EXCg_ECxg	*/
#define EM_MSRUP	(1 << E_MSRUP)	  /* }EXCgAbvCxg	*/
#define EM_KEYDOWN	(1 << E_KEYDOWN)  /* L[_ECxg		*/
#define EM_KEYUP	(1 << E_KEYUP)	  /* L[AbvCxg		*/
#define EM_UPDATE	(1 << E_UPDATE)	  /* Abvf[gCxg	*/
#define EM_RESERVE1	(1 << E_RESERVE1) /* VXe\P		*/
#define EM_ACTIVATE	(1 << E_ACTIVATE) /* ANeBx[gCxg	*/
#define EM_RESERVE2	(1 << E_RESERVE2) /* VXe\Q		*/
#define EM_RESERVE3	(1 << E_RESERVE3) /* VXe\R		*/
#define EM_SYSTEM1	(1 << E_SYSTEM1)  /* VXeCxgP		*/
#define EM_SYSTEM2	(1 << E_SYSTEM2)  /* VXeCxgQ		*/
#define EM_USER1	(1 << E_USER1)	  /* [U[CxgP		*/
#define EM_USER2	(1 << E_USER2)	  /* [U[CxgQ		*/
#define EM_EVERY	0xffff		  /* ׂẴCxg		*/

struct Event {				/* CxgR[h		*/
	short what;			/* CxgR[h		*/
	union {
		Window *win;		/* EBhE|C^		*/
		struct {
			short code;	/* L[R[h			*/
			short ascii;	/* ASCIIR[h			*/
		} key;
		long data;
	} whom;				/* CxgbZ[Wiṕj	*/
	unsigned long when;		/* CxgVXe	*/
	Point where;			/* Cxg̃|C^W
					   iO[oWnj		*/
	unsigned long how;		/* VtgL[rbg		*/
};
/*
 *	EBhE} (Window Man)
 */
#define NONTITLE	(_LASCII)"\0"	/* ^Cg			*/

struct Window {				/* EBhER[h		*/
	Graph graph;			/* OtR[h		*/
	unsigned short kind;		/* EBhE̎		*/
	char visible;			/* tO			*/
	char hilite;			/* ANeButO		*/
	char close;			/* N[Y{^gptO	*/
	char status;			/* EBhEXe[^X		*/
	unsigned short option;		/* EBhEIvV		*/
	Region **outside;		/* AEgTCh[Wnh */
	Region **inside;		/* CTCh[Wnh	*/
	Region **update;		/* Abvf[g[Wnh */
	long (**def)();			/* EBhE`֐ւ̃nh */
	long defData;			/* EBhE`֐̃f[^	*/
	LASCII **title;			/* EBhE^Cgւ̃nh */
	unsigned short tWidth;		/* ^Cg̕			*/
	Control **control;		/* Rg[nh		*/
	Window *next;			/* ̃EBhE|C^	*/
	GScript **gScript;		/* EBhEXNvgnh	*/
	long taskID;			/* ^XNhc			*/
};
/*
 *	TuEBhE}iSub Window Manj
 */
/* TuEBhE̊eVXeWl */
#define WS_INSIDE_X	1		/* CTCh[W̍xW */
#define WS_INSIDE_Y	18		/* CTCh[W̍yW */
#define WS_CLOSE_W	10		/* TuEBhEpN[Y{^̕ */

struct Subwin {				/* TuEBhER[h	*/
	Window win;			/* EBhER[h		*/
	unsigned long priority;		/* vCIeBl		*/
};
/*
 *	Rg[} (Control Man)
 */
/* eRg[̑傫iVXeWlj*/
#define CHRBTN_H	6		/* {^̍ŏ
					   i{̒j		*/
#define CHRBTN_V	19		/* {^̍		*/
#define RADBTN_H	32		/* WI{^̕		*/
#define RADBTN_V	9		/* WI{^̍		*/
#define CHKBOX_H	13		/* `FbN{bNX̕		*/
#define CHKBOX_V	13		/* `FbN{bNX̍	*/
#define SLDVOL_H	14		/* XCh{[̍ŏ
					   i{XCho[̒j	*/
#define SLDVOL_V	16		/* XCh{[̍	*/
#define ADJBTN_H	48		/* l{^̕		*/
#define ADJBTN_V	18		/* l{^̍		*/
#define SCRLBR_H	18		/* XN[o[̕		*/
/*
 *	^XN} (Task Man)
 */
#define TS_NAMEMAX	90		/* ^XN}ł̃t@C̍ő咷
					   i̒l͕ύXł܂j	*/

union TsEvent {				/* ^XN}CxgR[h	*/
	struct {
		short what;		/* CxgR[h		*/
		long whom;		/* P			*/
		unsigned long when;	/* CxgVXe	*/
		long whom2;		/* Q			*/
		short what2;		/* ^XN}CxgR[h^
					   bZ[WR[h		*/
		short taskID;		/* ̃^XNhc		*/
	} ts;
	Event ev;			/* CxgR[h		*/
};

#endif __SXDEF2_H
